#!/usr/bin/env ruby
#
# Copyright (C) 2009, Oy L M Ericsson Ab, NomadicLab <pubsub@nomadiclab.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# Alternatively, this software may be distributed under the terms of the BSD
# license.
#
# See LICENSE and COPYING for more details.
#

require 'libpsirp_rb'

len = 20000 # just testing
sid = "\000" * Libpsirp_rb::PSIRP_ID_LEN
rid = "b" * Libpsirp_rb::PSIRP_ID_LEN

p "psirp_create(" + len.to_s + "):"
x = Libpsirp_rb.psirp_create(len)
p x
ppub = x[1]

p "psirp_rb_buffer(" + ppub.to_s + ")[0]:"
pbuf = Libpsirp_rb.psirp_rb_buffer(ppub)
p pbuf[0]

#pbuf[0] = "\0ff"

p "psirp_publish(" + sid + "," + rid + "," + ppub.to_s + "):"
y = Libpsirp_rb.psirp_publish(sid, rid, ppub)
p y

p "psirp_subscribe(" + sid + "," + rid + "):"
z = Libpsirp_rb.psirp_subscribe(sid, rid)
p z
spub = z[1]

p "psirp_rb_buffer(" + spub.to_s + ")[0]:"
sbuf = Libpsirp_rb.psirp_rb_buffer(spub)
p sbuf[0]

