/*
* Copyright (C) 2009, Oy L M Ericsson Ab, NomadicLab <pubsub@nomadiclab.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License version 2 as
* published by the Free Software Foundation.
*
* Alternatively, this software may be distributed under the terms of the BSD
* license.
*
* See LICENSE and COPYING for more details.
*/


//#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <sys/queue.h>
//#include <sys/types.h>
//#include <inttypes.h>

#include <sys/param.h>
#include <libpsirp.h>
#include "../../libpsirp/src/psirp_debug.h"

#include "psirp_common_types.h"
#include "psirpd_types.h"
//#include "psirp_io.h"
#include "psirp.h"
//#include "psirp_debug.h"
//#include "psirpd_hdrs.h"//to include BF SIZE
#include "psirpd_bloom_interface.h"


static int bf_elems = 0;
LIST_HEAD(bf_list, bf_list_item) bf_list_head;

psirp_error_t
psirpd_bloom_interface_init(void) {

    ENTER();

    LIST_INIT(&bf_list_head);

    RETURN PSIRP_OK;
}

psirp_error_t
psirpd_bloom_interface_cleanup(void) {

    bf_list_item_t *bf, *bf1;

    ENTER();

	LIST_FOREACH_SAFE(bf, &bf_list_head, entries, bf1) {
        LIST_REMOVE(bf, entries);
        /* Clean up things included in bf... */
        free(bf);
    }

    RETURN PSIRP_OK;
}

psirp_error_t psirpd_bloom_interface_add(char *if_name, u_int8_t bf[PSIRP_FID_LEN]){

	bf_list_item_t *bfp = NULL;

    ENTER();

    bfp = (bf_list_item_t *)malloc(sizeof(bf_list_item_t));
	PSIRP_ETL(bfp == NULL, PSIRP_DBG_ERR, PSIRP_FAIL_MALLOC,
	              "Cannot allocate memory");


	memcpy(bfp-> bf,bf, (sizeof(u_int8_t)*PSIRP_FID_LEN));
	memcpy(bfp-> if_name, if_name, strlen(if_name));

	LIST_INSERT_HEAD(&bf_list_head, bfp, entries);

	bf_elems++;

	RETURN PSIRP_OK;
}
psirp_error_t psirpd_bloom_interface_remove(char *if_name){
	ENTER();


	RETURN PSIRP_OK;
}
psirp_error_t psirpd_bloom_interface_find(char *if_name, bf_list_item_t **bf){
	bf_list_item_t *bfp;

	    ENTER();

	    LIST_FOREACH(bfp, &bf_list_head, entries) {
	        if (!memcmp(bfp-> if_name, if_name, strlen(if_name))) {
	            *bf = bfp;
	            RETURN PSIRP_OK;
	        }
	    }

	    RETURN PSIRP_FAIL_NOTFOUND;
}
