/*
* Copyright (C) 2009, Oy L M Ericsson Ab, NomadicLab <pubsub@nomadiclab.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License version 2 as
* published by the Free Software Foundation.
*
* Alternatively, this software may be distributed under the terms of the BSD
* license.
*
* See LICENSE and COPYING for more details.
*/

#ifndef PSIRPD_BLOOM_INTERFACE_H_
#define PSIRPD_BLOOM_INTERFACE_H_

#include <sys/queue.h>
//#include <pcap.h>


struct bf_list_item {
    LIST_ENTRY(bf_list_item) entries;
    uint8_t bf[PSIRP_FID_LEN];
    char *if_name;
};

typedef struct bf_list_item bf_list_item_t;

struct bloom_pcap_dev
{
    //pcap_t *pcap_dev;
    uint8_t bloomf[PSIRP_FID_LEN];
};

typedef struct bloom_pcap_dev bloom_pcap_dev_t;


psirp_error_t psirpd_bloom_interface_init(void);
psirp_error_t psirpd_bloom_interface_cleanup(void);
psirp_error_t psirpd_bloom_interface_add(char *if_name, u_int8_t bf[PSIRP_FID_LEN]);
psirp_error_t psirpd_bloom_interface_remove(char *if_name);
psirp_error_t psirpd_bloom_interface_find(char *if_name, bf_list_item_t **bf);

#endif /* PSIRPD_BLOOM_INTERFACE_H_ */
