/*
* Copyright (C) 2009, Oy L M Ericsson Ab, NomadicLab <pubsub@nomadiclab.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License version 2 as
* published by the Free Software Foundation.
*
* Alternatively, this software may be distributed under the terms of the BSD
* license.
*
* See LICENSE and COPYING for more details.
*/

//#include <stdlib.h>
//#include <unistd.h>
//#include <errno.h>
//#include <stdio.h>
#include <string.h>
//#include <pcap.h>
#include <sys/queue.h>
//#include <net/ethernet.h>
//#include <netinet/in.h>

#include <sys/param.h>
#include <libpsirp.h>
#include "../../libpsirp/src/psirp_debug.h"

#include "psirp_common_types.h"
#include "psirpd_types.h"
//#include "psirp.h"
//#include "psirp_io.h"
//#include "psirp_debug.h"
//#include "psirpd_pl.h"
//#include "psirpd_protocol.h"
//#include "psirpd_hdrs.h"


psirp_error_t
psirpd_protocol_init(void)
{
    ENTER();

    RETURN PSIRP_OK;
}


void
psirpd_protocol_cleanup(void)
{
    ENTER();

    RETURN;
}

#if 0
psirp_error_t
psirpd_protocol_handle(bloom_pcap_dev_t *dev)
{
    struct pcap_pkthdr *hdr = NULL;
    const unsigned char *data = NULL;
    struct ether_header *eth;
    struct psirpd_hdrs_fwhdr *ps; /* PSIRP forwarding header */
    struct psirpd_hdrs_rzvhdr *rzv; /* Rendezvous header */
    const unsigned char *payload; /* Packet payload */
    int forward = 1;
    int err;
    int i = 0;
    int j = 0;
    uint8_t  interface_id[NO_INTERFACES][PSIRP_FID_LEN];// perhaps should be defined in a table somewhere else


    ENTER();

    /* read packet */
    // should mark the incoming link somewhere

    err = pcap_next_ex(dev->pcap_dev, &hdr, &data);
    PSIRP_ETL(err == 0, PSIRP_FAIL_PCAP_CAPTURE, PSIRP_DBG_ERR,
              "Live capture timeouted: %s", pcap_geterr(dev->pcap_dev));
    PSIRP_ETL(err == -1, PSIRP_FAIL_PCAP_CAPTURE, PSIRP_DBG_INFO,
              "Error while capturing packet: %s", pcap_geterr(dev->pcap_dev));

    /* check headers:
     * pcap_pkthdr = { timestamp, captured length, packet length }
     */

    eth = (struct ether_header *)(data);
    if (eth->ether_type != htons(0xACDC)) {
        PSIRP_ETL(1, PSIRP_FAIL_ETH_TYPE, PSIRP_DBG_WARN,
                  "Captured non-pubsub packet: 0x%x", htons(eth->ether_type));
    }

    	ps = (struct psirpd_hdrs_fwhdr *)(data + SIZE_ETHERNET);
    	rzv = (struct psirpd_hdrs_rzvhdr *)(data + SIZE_ETHERNET + sizeof( struct psirpd_hdrs_fwhdr) );
        payload = (unsigned char *)(data + SIZE_ETHERNET + sizeof( struct psirpd_hdrs_fwhdr) + sizeof( struct psirpd_hdrs_rzvhdr));

    	for (i = 0; i< NO_INTERFACES; ++i)
    	{
    		for (j = 1; j < PSIRP_FID_LEN; ++j) // first 8 bits of bloom filter is reserved for flags and so on, it does not contain the link id
    		//if (i != interface )
    			if((ps-> FID[j] & interface_id[i][j]) != interface_id[i][j])
    			{
    				forward = 0; // FID does not match this interface id
    				break;
    			}
    		//if(forward)
    			//TODO send(data,i);
    			//forward it on link i= pcap_sendpacket() or pcap_inject(data(stripped 14))
    	}

    	//upper layer functionality
    	/*switch (rzv->msg_type)
    	{

    	case '0'://data packet: check the local RID registrations against chunk(header) RIDs

    		break;
    	case '1'://publish: Check if this node is the destined serving point for that SID

    		break;
    	case '2'://subscribe : Check if requested RID(and/or SID) exist in local memory, behave like local then call send, packet make,...

    		break;
    	default:
    		break;
    	};*/
    RETURN PSIRP_OK;
}
#endif
