#!/usr/local/bin/python2.6
#
# Copyright (C) 2009, Oy L M Ericsson Ab, NomadicLab <pubsub@nomadiclab.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# Alternatively, this software may be distributed under the terms of the BSD
# license.
#
# See LICENSE and COPYING for more details.
#

from psirp.libpsirp_py import *

PUB_LEN = 20000
SID = PSIRP_ID_LEN*'\x00'
RID = PSIRP_ID_LEN*'A'

# Subscribe data
print('psirp_subscribe(%r, %r)' % (SID, RID))
sv = psirp_subscribe(SID, RID)
if sv[0] != 0:
    print('psirp_subscribe failed: %r' % sv)
    exit(sv[0])
spub = sv[1]
del sv

# Get subscribed data as buffer
print('psirp_py_buffer(%r)' % (spub))
sbuf = psirp_py_buffer(spub)
print('sdata_buf: %r' % sbuf)

# Read from buffer
print('sbuf[%d], sbuf[%d]: %r...%r' \
          % (0, len(sbuf)-1, sbuf[0], sbuf[len(sbuf)-1]))

index = len(sbuf)/2
print("sbuf[%d]: %r, check if modified (y/n)?" % (index, sbuf[index]))
modify = raw_input()
if modify.lower() == 'y':
    print("sbuf[%d]: %r" % (index, sbuf[index]))

# Free publication
print("psirp_free(%r)" % spub)
psirp_free(spub);
